package com.muimi.mail.model;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.ui.IMemento;
import org.eclipse.ui.XMLMemento;

import com.muimi.mail.MailPlugin;
import com.muimi.mail.PluginPreference;

/**
 * AJEg̃[g
 * @author Shinji Miyamoto
 */
public class AccountRoot {

	private boolean debug = true;

	private List accounts = new ArrayList();



	public Account[] getAcounts(){
		return (Account[])accounts.toArray(new Account[0]);
	}

	public String getMailDataPath(){
		return PluginPreference.getMailDataPath();
	}
	
	public boolean isDebug(){
		return debug;
	}

	public void addAccount(Account account){
		accounts.add(account);
	}
	
	public void removeAccount(Account account, boolean isFileDelete){
		accounts.remove(account);
		if(isFileDelete){
			String path = account.getLocalStorePath();
			deleteFile(new File(path));
		}
	}
	
	private void deleteFile(File file){
		if(file.isDirectory()){
			File[] files = file.listFiles();
			for(int i=0; i<files.length; i++){
				deleteFile(files[i]);
			}
		}
		file.delete();
	}
	
	
	
	public void persist(){
		try {
			XMLMemento memento = XMLMemento.createWriteRoot("root");

			for(int i=0; i<accounts.size(); i++){
				Account account = (Account)accounts.get(i);
				IMemento child = memento.createChild("account");
				account.persist(child);
			}

			BufferedWriter out = 
				new BufferedWriter(
					new FileWriter(getDataFile()));				

			memento.save(out);
			out.close();
		} catch (IOException e) {
			MailPlugin.logError("fail to write account data", e);
		}
	}
	
	public void resotre(){
		File file = getDataFile();
		if(!file.exists()){
			System.out.println("data file is not exist");
			return;
		}

		try {
			BufferedReader in = 
				new BufferedReader(
					new FileReader(getDataFile()));
			XMLMemento memento = XMLMemento.createReadRoot(in);
			
			IMemento[] childs = memento.getChildren("account");
			for(int i=0; i<childs.length; i++){
				Account account = new Account();
				account.restore(childs[i]);
				accounts.add(account);
			}
			in.close();
		} catch (Exception e) {
			MailPlugin.logError("fail to read account data", e);
		}
	}
	
	private File getDataFile(){
		return new File(getMailDataPath() + "/accounts.xml");
	}

}
