package com.muimi.mail.ui;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.muimi.mail.model.Account;

/**
 * AJEgݒ肷EBWbgB
 * ݒy[WƃEBU[gŋp
 * @author Shinji Miyamoto
 */
public class AccountSettingPage {

	private IPreferenceStore store;

	private Map map = new HashMap();


	public AccountSettingPage(IPreferenceStore store){
		this.store = store;
	}


	public Composite createControl(Composite parent){
		
		
		Composite c =  new Composite(parent, SWT.NULL);
		c.setLayout(new GridLayout(2, false));
		
		addTextField(c, "label", 		Account.KEY_LABEL);
		addTextField(c, "pop3.host", 	Account.KEY_POP3_HOST);
		addTextField(c, "smtp.host", 	Account.KEY_SMTP_HOST);
		addTextField(c, "user", 		Account.KEY_USER);
		Text t = addTextField(c, "password", 	Account.KEY_PASSWORD);
		t.setEchoChar('*');
		addTextField(c, "user.address", Account.KEY_USER_ADDRESS);
		addTextField(c, "user.name", 	Account.KEY_USER_NAME);

		addCheckbox(c, "POP3 before SMTP g", Account.KEY_POP3BEFORESMTP);
		addCheckbox(c, "T[oɃbZ[Wc", Account.KEY_LEAVEONSERVERMESSAGE);

		
		addSample(c);
		

		return c;
	}


	//for test
	private void addSample(Composite parent){
		Composite c = new Composite(parent, SWT.NULL);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 2;
		c.setLayoutData(gd);
		c.setLayout(new RowLayout());
		
		Button b1 = new Button(c, SWT.NULL);
		b1.setText("yahoo");
		b1.addSelectionListener(new SelectionListener(){

			public void widgetSelected(SelectionEvent e) {
				setText(Account.KEY_LABEL, "yahoo");
				setText(Account.KEY_POP3_HOST, "pop.mail.yahoo.co.jp");
				setText(Account.KEY_SMTP_HOST, "smtp.mail.yahoo.co.jp");
				setText(Account.KEY_USER,      "kabukin3");
				setText(Account.KEY_PASSWORD,  "3kabukin");
				setText(Account.KEY_USER_ADDRESS, "kabukin3@yahoo.co.jp");
				setText(Account.KEY_USER_NAME, "hoge hogezo");
				setCheck(Account.KEY_POP3BEFORESMTP, true);
				setCheck(Account.KEY_LEAVEONSERVERMESSAGE, true);
			}

			public void widgetDefaultSelected(SelectionEvent e) {
			}
		});
	}
	private void setText(String key, String value){
		Text f = (Text)map.get(key);
		f.setText(value);
	}
	private void setCheck(String key, boolean value){
		Button b = (Button)map.get(key);
		b.setSelection(value);
	}


	private Text addTextField(Composite c, String labelText, String key){

		Label label = new Label(c, SWT.NULL);
		label.setText(labelText);
		Text text = new Text(c, SWT.BORDER);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.widthHint = 200;
		text.setLayoutData(gd);
		
		String value = store.getString(key);
		if(value != null){
			text.setText(value);
		}

		map.put(key, text);
		
		return text;
	}


	private GridData gd(){
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.widthHint = 200;
		return gd;
	}

	private void addCheckbox(Composite c, String labelText, String key){

		Label label = new Label(c, SWT.NULL);
		label.setText(labelText);
		Button button = new Button(c, SWT.CHECK);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		
		if(store.getBoolean(key)){
			button.setSelection(true);
		}else{
			button.setSelection(false);
		}

		map.put(key, button);
	}






	public IPreferenceStore getPreference(){
		Iterator iter = map.keySet().iterator();
		while (iter.hasNext()) {
			String key = (String) iter.next();
			Object c = map.get(key);

			if(c instanceof Text){
				String value = ((Text)c).getText();
				store.setValue(key, value);
			}else if(c instanceof Button){
				boolean value = ((Button)c).getSelection();
				store.setValue(key, value);
			}else{
				
			}

		}
		return store;
	}

}

