package com.muimi.mail.ui.editor;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import javax.mail.MessagingException;
import javax.mail.Part;
import javax.mail.internet.MimeUtility;

/**
 * t@C킷NXB
 * Ytt@C̑ɗp
 * @author Shinji Miyamoto
 */
public class PortableFile {

	private String name;
	private byte[] data;
	private File localFile;


	public PortableFile(Part part) throws IOException, MessagingException{
		
		name = part.getFileName();
		if(name != null){
			name = MimeUtility.decodeText(name);
		}else{
			if(part.isMimeType("text/html")){
				name = "attach.html";
			}else{
				name = "attahcment";
			}
		}

		data = createData(part.getInputStream());
	}


	public PortableFile(File localFile) throws IOException{
		name = localFile.getName();
		this.localFile = localFile;
		//data = createData(new FileInputStream(localFile));
	}


	private byte[] createData(InputStream in) throws IOException{
		ByteArrayOutputStream ba = new ByteArrayOutputStream();
		byte[] b = new byte[4096];
		int len;
		while( (len = in.read(b)) != -1){
			ba.write(b, 0, len);
		}
		byte[] data = ba.toByteArray();
		in.close();//inclose
		ba.close();
		return data;
	}


	public File getLocalFile(){
		return localFile;
	}


	/**
	 * @return
	 */
	public byte[] getData() {
		return data;
	}

	/**
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param bs
	 */
	public void setData(byte[] bs) {
		data = bs;
	}

	/**
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}

}
