/*
 * POP3Message.java
 *
 * Copyright (C) 1998-2000 FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright (C) 1998-2000N FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
 * \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
 * ̒炢ꂩIÃo[W߂ɏ]Ė{vO
 * ĔЕz܂͕ύX邱Ƃł܂B
 * {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
 * ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
 * GNU ʌLgpǂ݂B
 *
 * Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
 * ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA ֎莆ĂB
 */

package jp.gr.java_conf.roadster.net.pop;


import java.io.IOException;
import java.io.InputStream;
import java.io.LineNumberReader;
import java.io.OutputStream;
import java.io.StringReader;
import java.util.Date;
import java.util.Enumeration;
import java.util.StringTokenizer;
import javax.activation.DataHandler;
import javax.mail.Address;
import javax.mail.Flags;
import javax.mail.IllegalWriteException;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;

import javax.mail.internet.MimeMessage;

/**
 * POP3bZ[WNX.
 * ̃NX Read-only łAsetXXX()\bh addXXX()
 * \bh͎gpłȂ.<BR>
 *
 * bZ[W𑗐Mۂɂ{@link javax.mail.internet.MimeMessage MimeMessage}NXgp邱.
 */
public class POP3Message extends MimeMessage {
	/**
	 * POP3Message  Read-only Ȃ̂ŁAsetXXX(), addXXX() 
	 * \bhĂяoƁAMethodNotSupportedException
	 * ɂ̃G[bZ[Wi[ throw .
	 */
	private static final String READ_ONLY_ERROR_MESSAGE = "POP3Message is read-only";

	/**
	 * DateParser
	 */
	private static final DateParser dateParser = new DateParser();

	/**
	 * MessageIndex ւ̎QƁB
	 * ̃IuWFNg璼ڎQƂĂ܂Ȃ悤 Object ɂĂB
	 * iLXg΃ANZXłĂ܂j
	 */
	private Object internalID;
	
	/**
	 * MimeMessage Œ`ꂽ flags tB[hւ̒ڂ̃ANZX֎~B
	 * i͌dlnjHj
	 */
	private final Flags flags = null;
	
	/**
	 * bZ[WT[oɓ͂.
	 */
	private Date receivedDate;
	
	/**
	 * Content̍sB
	 */
	private int lineCount = -1;

	/**
	 * w肳ꂽtH_ւ̎QƂƃbZ[WԍCX^X쐬.
	 *
	 * @param	folder	POP3Folder̃CX^X.
	 * @param	msgnum	bZ[Wԍ.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	protected POP3Message(POP3Folder folder, int msgnum) throws MessagingException {
		super(folder, msgnum);
	}

	/**
	 * ftHgRXgN^.
	 *
	 * @param	folder	POP3Folder̃CX^X.
	 * @param	in		bZ[Wf[^̓̓Xg[.
	 * @param	msgnum	bZ[Wԍ.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	protected POP3Message(POP3Folder folder, InputStream in, int msgnum) throws MessagingException {
		super(folder, in, msgnum);
	}
	
	/**
	 * From tB[h𓾂.
	 *
	 * @return	FromtB[h.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Address[] getFrom() throws MessagingException {
		loadHeaders();
		return super.getFrom();
	}
	
	/**
	 * From ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param address	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setFrom(Address address) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * From ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setFrom() throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * From ǉ.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param addresses	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void addFrom(Address[] addresses) throws MessagingException {
		throw new javax.mail.IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * 𓾂.
	 *
	 * @param	type	̎.(RecipientType.CC or RecipientType.BCC)
	 * @return	̈ꗗ.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Address[] getRecipients(Message.RecipientType type) throws MessagingException {
		loadHeaders();
		return super.getRecipients(type);
	}
	
	/**
	 * ׂĂ̈𓾂.
	 *
	 * @return	̈ꗗ.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Address[] getAllRecipients() throws MessagingException {
		loadHeaders();
		return super.getAllRecipients();
	}

	/**
	 * Recipients ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param type	.
	 * @param addresses	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setRecipients(Message.RecipientType type,
								Address[] addresses) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Recipients ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param type	.
	 * @param addresses	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setRecipient(Message.RecipientType type, Address address) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Recipients ǉ.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param type	.
	 * @param addresses	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void addRecipients(Message.RecipientType type, Address[] addresses) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Recipient ǉ.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param type	.
	 * @param addresses	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void addRecipient(Message.RecipientType type, Address address) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}

	/**
	 * Reply-to 𓾂.
	 *
	 * @return	Reply-to
	 */
	public Address[] getReplyTo() throws MessagingException {
		loadHeaders();
		return super.getReplyTo();
	}
	
	/**
	 * Reply-To ǉ.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param addresses	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setReplyTo(Address[] addresses) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Subject 𓾂.
	 *
	 * @return Subject.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public String getSubject() throws MessagingException {
		loadHeaders();
		return super.getSubject();
	}
	
	/**
	 * Subject ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param subject	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setSubject(String subject) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Subject ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param subject	.
	 * @param charset	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setSubject(String subject, String charset) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * M𓾂.
	 *
	 * @return	M.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Date getSentDate() throws MessagingException {
		loadHeaders();
		return super.getSentDate();
	}
	
	/**
	 * Mtݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param date	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setSentDate(Date date) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * M𓾂B
	 *
	 * @return	M.M݂Ȃꍇ null.
	 * @throws	javax.mail.MessagingException	G[ꍇ.
	 */
	public Date getReceivedDate() throws MessagingException {
		loadHeaders();
		if (receivedDate == null) {
			String rcvd[] = getHeader("Received");	// Ԑ擪 Received: wb_t𒊏oB
			if (rcvd != null && rcvd.length > 0) {
				StringTokenizer st = new StringTokenizer(rcvd[0], ";");
				if (st.countTokens() >= 2) {
					st.nextToken();
					String date = st.nextToken();
					receivedDate = dateParser.parse(date);
				}
			}
		}
		return receivedDate;
	}
	
	public int getSize() throws MessagingException {
		loadData();
		return super.getSize();
	}
	
	/**
	 * Content̍sԂB
	 *
	 * @return	sBsȏꍇ -1B
	 * @throws	javax.mail.MessagingException	G[ꍇB
	 */
	public int getLineCount() throws MessagingException {
		loadData();
		try {
			if (lineCount == -1) {
				Object o = super.getContent();
				//  this.getContent() Ă܂ƁASEEN tOĂ܂B
				if (o instanceof String) {
					lineCount = 0;
					LineNumberReader lcr = new LineNumberReader(new StringReader((String) o));
					while (lcr.readLine() != null) {
						lineCount++;
					}
					lcr.close();
				}
			}
		} catch (IOException ioe) {
			throw new MessagingException("IOException", ioe);
		}
		return lineCount;
	}
	
	/**
	 * Content-type 𓾂.
	 * "text" łꍇɂ "text/plain" Ԃ.
	 *
	 * @return	Content-type. "text"  "text/plain" ƂĕԂ.
	 * @exception	javax.mail.MessagingException	
	 */
	public String getContentType() throws MessagingException {
		loadData();
		String ctype = super.getContentType();
		if (ctype.equals("text")) {
			ctype = "text/plain";
		}
		return ctype;
	}
	
	public boolean isMimeType(String mimeType) throws MessagingException {
		loadData();
		return super.isMimeType(mimeType);
	}
	
	public String getDisposition() throws MessagingException {
		loadData();
		return super.getDisposition();
	}
	
	/**
	 * Content-Disposition ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param disposition	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setDisposition(String disposition) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public String getEncoding() throws MessagingException {
		loadData();
		return super.getEncoding();
	}
	
	/**
	 * Content-ID 𓾂.
	 *
	 * @return	Content-ID.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public String getContentID() throws MessagingException {
		loadHeaders();
		return super.getContentID();
	}
	
	/**
	 * Content-ID ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param cid	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setContentID(String cid) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Content-MD5 𓾂.
	 *
	 * @return	Content-MD5.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public String getContentMD5() throws MessagingException {
		loadHeaders();
		return super.getContentMD5();
	}
	
	/**
	 * Content-MD5 ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param md5	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setContentMD5(String md5) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Content-Description 𓾂.
	 *
	 * @return Content-Description.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public String getDescription() throws MessagingException {
		loadHeaders();
		return super.getDescription();
	}
	
	/**
	 * Content-Description ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param description	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setDescription(String description) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Content-Description ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param description	.
	 * @param charset	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setDescription(String description, String charset) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * Content-Language 𓾂.
	 *
	 * @return	Content-Language.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public String[] getContentLanguage() throws MessagingException {
		loadHeaders();
		return super.getContentLanguage();
	}
	
	/**
	 * Content-Language ݒ肷.
	 * POP3MessageRead-only Ȃ̂ŁAɗO throw .
	 *
	 * @param languages	.
	 * @exception	javax.mail.IllegalWriteException	 throw .
	 */
	public void setContentLanguage(String[] languages) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * "Message-ID" wb_tB[h𓾂.݂Ȃꍇ null Ԃ.
	 *
	 * @return	Message-ID.
	 * @exception javax.mail.MessagingException	炩̃G[ꍇ.
	 */
	public String getMessageID() throws MessagingException {
		loadHeaders();
		return super.getMessageID();
	}
	
	/**
	 * ̃bZ[WɊ֘Atꂽt@CԂ.
	 * "Content-Disposition" wb_tB[h "filename" p[^݂ꍇA̒lԂ.
	 * ݂ȂꍇA"Content-Type" wb_tB[h "name" p[^̒lԂ.
	 * Ƃ݂ȂꍇAnull Ԃ.
	 *
	 * @return	t@C.
	 * @throws javax.mail.MessagingException
	 */
	public String getFileName() throws MessagingException {
		loadHeaders();
		return super.getFileName();
	}
	
	public void setFileName(String filename) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public InputStream getInputStream() throws java.io.IOException, MessagingException {
		loadData();
		if (! isSet(Flags.Flag.SEEN)) {
			setFlag(Flags.Flag.SEEN, true);
		}
		return super.getInputStream();
	}
	
	protected InputStream getContentStream() throws MessagingException {
		loadData();
		return super.getContentStream();
	}
	
	public DataHandler getDataHandler() throws MessagingException {
		loadData();
		return super.getDataHandler();
	}
		
	public Object getContent() throws IOException, MessagingException {
		loadData();
		if (! isSet(Flags.Flag.SEEN)) {
			setFlag(Flags.Flag.SEEN, true);
		}
		return super.getContent();
	}

	public void setDataHandler(DataHandler dh) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public void setContent(Object o, String type) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public void setText(String text) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public void setText(String text, String charset) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public void setContent(Multipart mp) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * ԐMbZ[W쐬.
	 *
	 * @param	replyToAll	Sւ̕ԐMbZ[W쐬ꍇ true.
	 * @return	ԐMbZ[W.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Message reply(boolean replyToAll) throws MessagingException {
		loadData();
		return super.reply(replyToAll);
	}
	
	/**
	 * w肳ꂽXg[ɁAbZ[W̓eo͂.
	 *
	 * @param	os	o̓Xg[.
	 * @exception	java.io.IOException	G[ꍇ.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public void writeTo(OutputStream os) throws IOException, MessagingException {
		loadData();
		super.writeTo(os);
	}
	
	public void writeTo(OutputStream os, String[] ignoreList) throws java.io.IOException, MessagingException {
		loadData();
		super.writeTo(os, ignoreList);
	}
	
	/**
	 * w肳ꂽÕwb_𓾂.
	 *
	 * @param	name	wb_̖O.
	 * @return	wb_̓e.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public String[] getHeader(String name) throws MessagingException {
		loadHeaders();
		return super.getHeader(name);
	}
	
	/**
	 * w肳ꂽÕwb_𓾂.
	 * l݂ꍇAdelimiter ŋ؂.
	 *
	 * @param	name	wb_.
	 * @param	delimiter	߂l͂̕ŋ؂.
	 * @return	wb_̓e.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public String getHeader(String name, String delimiter) throws MessagingException {
		loadHeaders();
		return super.getHeader(name, delimiter);
	}
	
	public void setHeader(String name, String value) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public void addHeader(String name, String value) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	public void removeHeader(String name) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	/**
	 * SẴwb_𓾂.
	 *
	 * @return	wb_񋓂 Enumeration.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Enumeration getAllHeaders() throws MessagingException {
		loadHeaders();
		return super.getAllHeaders();
	}
	
	/**
	 * w肳ꂽ̂Ɉvwb_ԂB
	 *
	 * @param	names	wb_̖O
	 * @param	wb_񋓂 Enumeration
	 * @throws	javax.mail.MessagingException	G[ꍇB
	 */
	public Enumeration getMatchingHeaders(String[] names) throws MessagingException {
		loadHeaders();
		return super.getMatchingHeaders(names);
	}
	
	public Enumeration getNonMatchingHeaders(String[] names) throws MessagingException {
		loadHeaders();
		return super.getNonMatchingHeaders(names);
	}
	
	public void addHeaderLine(String line) throws MessagingException {
		throw new IllegalWriteException(READ_ONLY_ERROR_MESSAGE);
	}
	
	
	public Enumeration getAllHeaderLines() throws MessagingException {
		loadHeaders();
		return super.getAllHeaderLines();
	}

	public Enumeration getMatchingHeaderLines(String[] names) throws MessagingException {
		loadHeaders();
		return super.getMatchingHeaderLines(names);
	}
	
	public Enumeration getNonMatchingHeaderLines(String[] names) throws MessagingException {
		loadHeaders();
		return super.getNonMatchingHeaderLines(names);
	}
	
	/**
	 * tO𓾂.
	 *
	 * @return	tO.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public Flags getFlags() throws MessagingException {
		return ((POP3Folder) getFolder()).getMessageFlags(this);
	}
	
	/**
	 * w肵tOݒ肳Ă邩Ԃ.
	 *
	 * @param	flag	ݒ肳Ă邩𒲂ׂtO.
	 * @return	ݒ肳Ăꍇ true.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public boolean isSet(Flags.Flag flag) throws MessagingException {
		return getFlags().contains(flag);
	}
	
	/**
	 * Flags Zbg.
	 *
	 * @param	flag
	 * @param	set
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public void setFlags(Flags flags, boolean set) throws MessagingException {
		Message[] msgs = new Message[1];
		msgs[0] = this;
		((POP3Folder) folder).setFlags(msgs, flags, set);
	}

	/**
	 * Flag Zbg.
	 *
	 * @param	flag
	 * @param	set
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	public void setFlag(Flags.Flag flag, boolean set) throws MessagingException {
		Flags flags = new Flags(flag);
		setFlags(flags, set);
	}

	public void saveChanges() throws MessagingException {
		loadData();
		super.saveChanges();
	}
	
	protected void updateHeaders() throws MessagingException {
		loadData();
		super.updateHeaders();
	}
	
	//--- ́APOP3Message ŗL̃\bh.
	
	/**
	 * MessageIndex ݒ肷.
	 *
	 * @param	id	ID
	 */
	void setInternalID(Object id) {
		this.internalID = id;
	}
	
	/**
	 * bZ[W̓ID𓾂.
	 *
	 * @return	ID
	 */
	Object getInternalID() {
		return internalID;
	}
	
	/**
	 * bZ[Wԍݒ肷.
	 *
	 * @param	msgnum	bZ[Wԍ.
	 */
	protected void setMessageNumber(int msgnum) {
		super.setMessageNumber(msgnum);
	}
	
	/**
	 * bZ[Wu폜ꂽvԂɂ.
	 *
	 * @param	expunged	폜Ԃɂꍇɂ true.
	 */
	protected void setExpunged(boolean expunged) {
		super.setExpunged(expunged);
	}
	
	/**
	 * wb_[h.
	 *
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	private synchronized void loadHeaders() throws MessagingException {
		if (headers != null || folder == null) {
			return;
		}
		headers = ((POP3Folder) folder).getMessageHeaders(this);
	}
		
	/**
	 * bZ[Wf[^[h.
	 *
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 */
	private synchronized void loadData() throws MessagingException {
		loadHeaders();
		if (content != null || folder == null) {
			return;
		}
		content = ((POP3Folder) folder).getMessageContentBytes(this);
	}
}
